/***************************************************************
 * Name:      gauge.cpp
 * Purpose:   Code for Dialog gauge
 * Author:    Salvador Pozo (salvapozo@gmail.com)
 * Created:   2024-11-29
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#include "gauge.h"

wxBEGIN_EVENT_TABLE(gauge, wxDialog)
    EVT_CLOSE(gauge::OnClose)
    EVT_TIMER(idtemp, gauge::OnTimer)
wxEND_EVENT_TABLE()

gauge::gauge(wxWindow *wnd)
    : wxDialog(wnd, -1, _T("Ejemplo de gauge")), m_temp(this, idtemp)
{
    wxBoxSizer *boxVertical;
    wxBoxSizer *boxHorizontal;

    boxVertical = new wxBoxSizer(wxVERTICAL);

    boxHorizontal = new wxBoxSizer(wxHORIZONTAL);
    m_gauge1 = new wxGauge(this, idGauge1, 100, wxDefaultPosition, wxSize(200, wxDefaultCoord), wxGA_SMOOTH);
    boxHorizontal->Add(m_gauge1, wxSizerFlags().Border());
    boxVertical->Add(boxHorizontal, wxSizerFlags().Border(wxTOP).Right());

    boxHorizontal = new wxBoxSizer(wxHORIZONTAL);
    m_gauge2 = new wxGauge(this, idGauge2, 10, wxDefaultPosition, wxSize(200, wxDefaultCoord));
    boxHorizontal->Add(m_gauge2, wxSizerFlags().Border());
    boxVertical->Add(boxHorizontal, wxSizerFlags().Border(wxTOP).Right());

    boxVertical->Add(CreateStdDialogButtonSizer(wxOK | wxCANCEL), wxSizerFlags().Border());

    SetSizerAndFit(boxVertical);

    m_gauge1->SetValue(0);
    m_temp.Start(100);
    m_gauge2->Pulse();
}

gauge::~gauge()
{
    //dtor
}

void gauge::OnClose(wxCloseEvent& event) {
    Destroy();
}

void gauge::OnTimer(wxTimerEvent& event) {
    m_gauge1->SetValue(m_gauge1->GetValue()+1);
    if(m_gauge1->GetValue() >= 100) {
        m_temp.Stop();
        m_gauge2->SetRange(1);
        m_gauge2->SetValue(1);
    }
}

